<!DOCTYPE html>
<html lang="en">
<head>
  <%- include('../partials/head.ejs'); -%>
</head>
<body>
<div class="container bg-3">

  <%- include('../partials/header.ejs'); -%>
  <%
  let status = [
                  {value : "Active", title :"Active"},
                  {value : "Inactive", title :"Inactive"}
                ]
  %>
  <div class="row">
        <div class="row">
          <div class="col-sm-6 col-sm-offset-3">
            <div class="row">
              <div class="col-sm-12">
                <% if(error){ %>
                  <div class="alert alert-danger"><%= error %></div>
              <% } %>
              </div>
            </div>
          </div><!--/col-sm-6-->
        </div><!--/row-->
        <% if(patient == "patients not found"){ %>
            <h4>Patient not found.</h4>
        <% }else{ %>
        <div class="main-container mt-2" style="background-color: rgb(255, 255, 255)">
          <div class="row">
            <div class="col">
              <div class="detailsNav">
                <ul class="nav nav-tabs">
                  <li class="active"><a data-toggle="tab" href="#general">General</a></li>
                  <li><a data-toggle="tab" href="#appointment">Schedule</a></li>
                  <li><a data-toggle="tab" href="#medication">Medication</a></li>
                  <li><a data-toggle="tab" href="#tests">Tests</a></li>
                </ul>
                <div class="tab-content">
                  <div id="general" class="tab-pane fade in active">
                    <h3>General Information</h3>
                    <div class="generalDetails">
                      <div class="col col-md-6">

                        <div class="alert alert-success successPatient" style="display:none"> </div>
                        <div class="alert alert-danger errorPatient" style="display:none"> </div>

                        <form id="updatePatient" class="updateForm" action="/members/update" data-id="<%=patient._id%>" method="POST">
                          <div class="form-group col-md-12">
                             <span for="status" class="col-md-6">Status</span>
                             <select id="status" name="status" class="select2Dropdown select2-single col-md-6">
                               <option></option>
                               <% status.forEach(function(stat, statusIndex){
                                 var selected = ""
                                 if(stat.value == patient.status){
                                   selected = "selected"
                                 }
                                 %>
                                 <option value="<%= stat.value %>" <%= selected %> ><%= stat.title %></option>
                               <% })  %>
                             </select>
                           </div>
                          <div class="form-group col-md-12">
                             <span for="patientID" class="col-md-6">DR ChronoID</span>
                             <input type="text" class="input-lg formControlCss col-md-6" name="patientID" id="patientID" placeholder="DR ChronoID" value="<%= patient.patientID %>">
                           </div>
                          <div class="form-group col-md-12">
                             <span for="firstName" class="col-md-6">First Name</span>
                             <input type="text" class="input-lg formControlCss col-md-6" name="firstName" id="firstName" placeholder="First Name" value="<%= patient.firstName %>">
                           </div>
                           <div class="form-group col-md-12">
                              <span for="lastName" class="col-md-6">Last Name</span>
                              <input type="text" class="input-lg formControlCss col-md-6" name="lastName" id="lastName" placeholder="Last Name" value="<%= patient.lastName %>">
                            </div>
                            <div class="form-group col-md-12">
                               <span for="email" class="col-md-6">Email</span>
                               <input type="email" class="input-lg formControlCss col-md-6" name="email" id="email" placeholder="email" value="<%= patient.email %>">
                             </div>
                             <div class="form-group col-md-12">
                                <span for="phone" class="col-md-6">Mobile #</span>
                                <input type="number" class="input-lg formControlCss col-md-6" name="phone" id="phone" placeholder="Phone" value="<%= patient.phone %>">
                              </div>
                            <div class="form-group col-md-12">
                               <span for="password" class="col-md-6">Password</span>
                               <span  class="btn col-md-6" id="updatepassword">Reset</span>
                               <input type="password" class="input-lg formControlCss col-md-6" name="password" id="password" placeholder="password" style="display:none">
                             </div>

                             <div class="form-group col-md-12">
                                <span for="status" class="col-md-6">Doctor</span>
                                <select id="doctorID" name="doctorID" class="select2Dropdown select2-single col-md-6">
                                  <option></option>
                                  <% doctors.forEach(function(doctor, doctorIndex){
                                    var selected = ""
                                    if(doctor._id == patient.doctorID){
                                      selected = "selected"
                                    }
                                    %>
                                    <option value="<%= doctor._id %>" <%= selected %>><%= doctor.first_name %> <%= doctor.last_name %></option>
                                  <% })  %>
                                </select>
                              </div>
                         </form>
                         <div class="col-md-12 text-right">
                           <button  class="btn" id="updatePatientButton">Update Patient</button>
                         </div>
                      </div>
                    </div>
                  </div>
                  <div id="appointment" class="tab-pane fade">
                    <h3>Appointments</h3>
                    <% if(appointments == ""){ %>
                        <h4 class="text-center">No appointments yet.</h4>
                    <% }else{ %>
                      <div class="table-responsive mt-5">
                        <table class="table table-bordered table-striped table-hover users-table mb-2">
                          <thead>
                            <tr>
                              <th>DRChrono Appointment ID</th>
                              <th>Date</th>
                              <th>Type</th>
                              <th>Sub Type</th>
                              <th>createdAt</th>
                              <th class="no-sort">Actions</th>
                            </tr>
                          </thead>
                          <tbody>
                            <% appointments.forEach(function(appointment, appointmentIndex){  %>
                            <tr>
                                <td><%= (appointment.drChronoAppintmentID) ? appointment.drChronoAppintmentID : "-" %></td>
                                <td><%= (appointment.scheduled_time) ? moment(appointment.scheduled_time).format('DD.MM.YYYY') : "-" %></td>
                                <td><%= (appointment.appointmentType) ? appointment.appointmentType : "-" %></td>
                                <td>
                                  <% if(appointment.appointmentType == "Appointment"){ %>
                                  <%= (appointment.doctor && appointment.doctor.name) ? appointment.doctor.name : "-" %>
                                  <% } %>
                                </td>
                                <td><%= (appointment.createdAt) ? moment(appointment.createdAt).format('DD.MM.YYYY') : "-" %></td>
                                <td>
                                  <button class="btn" data-toggle="modal" data-target="#appointmentDetails_<%= appointment._id %>" ><i class="fa fa-eye"></i></button>
                                </td>
                            </tr>
                            <!-- Details Modal -->
                                <div class="modal fade" id="appointmentDetails_<%= appointment._id %>" role="dialog">
                                  <div class="modal-dialog">
                                                  <!-- Modal content-->
                                   <div class="modal-content">
                                     <div class="modal-header">
                                       <button type="button" class="close" data-dismiss="modal">&times;</button>
                                       <h4 class="modal-title">Appointment Details</h4>
                                     </div>
                                     <div class="modal-body">
                                       <div class="generalDetails">
                                         <fieldset>
                                            <legend>General info </legend>
                                             <span class="col-md-6">DRChrono Appointment ID</span> <span class="col-md-6"><%= (appointment.drChronoAppintmentID) ?  appointment.drChronoAppintmentID : "-" %></span>
                                             <span class="col-md-6">DRChrono PatientID</span> <span class="col-md-6"><%= (appointment.patientID) ?  appointment.patientID : "-" %></span>
                                             <span class="col-md-6">Scheduled Time</span> <span class="col-md-6"><%= (appointment.scheduled_time) ?  appointment.scheduled_time : "-" %></span>
                                             <span class="col-md-6">Status</span> <span class="col-md-6"><%= (appointment.status) ?  appointment.status : "-" %></span>
                                             <span class="col-md-6">Notes</span>
                                             <span class="col-md-6">
                                               <textarea rows="5" cols="26" disabled><%= appointment.notes %></textarea>
                                             </span>
                                           </fieldset>
                                           <fieldset>
                                              <legend>Doctor </legend>
                                               <span class="col-md-6">Doctor Name</span> <span class="col-md-6"><%= (appointment.doctor && appointment.doctor.name) ? appointment.doctor.name : "-" %></span>
                                               <span class="col-md-6">Doctor Pic</span>
                                               <span class="col-md-6"><% if(appointment.doctor && appointment.doctor.profile_picture) { %> <img src="/<%= appointment.doctor.profile_picture%>" height="100" width="100"/> <% }else{ %> - <% } %></span>
                                           </fieldset>
                                           <fieldset>
                                              <legend>Zoom Meeting</legend>
                                               <span class="col-md-6">Zoom MeetingID</span> <span class="col-md-6"><%= (appointment.zoomMeetingID) ?  appointment.zoomMeetingID : "-" %></span>
                                               <span class="col-md-6">Zoom Meeting Status</span> <span class="col-md-6"><%= (appointment.zoomMeetingStatus) ?  appointment.zoomMeetingStatus : "-" %></span>
                                               <span class="col-md-6">Zoom Meeting StartTime</span> <span class="col-md-6"><%= (appointment.zoomMeetingStartTime) ?  appointment.zoomMeetingStartTime : "-" %></span>
                                               <span class="col-md-6">Zoom Meeting EndTime</span> <span class="col-md-6"><%= (appointment.zoomMeetingEndTime) ?  appointment.zoomMeetingEndTime : "-" %></span>
                                               <span class="col-md-6">Zoom Meeting Duration</span> <span class="col-md-6"><%= (appointment.zoomMeetingDuration) ?  appointment.zoomMeetingDuration : "-" %></span>
                                            </fieldset>
                                       </div>
                                     </div>
                                     <div class="clearfix"></div>
                                     <div class="modal-footer">
                                       <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                                     </div>
                                   </div>

                                 </div>
                               </div>
                          <!-- Details Modal -->
                            <% }) %>
                          </tbody>
                        </table>
                      </div>
                    <% } %>
                  </div>
                  <div id="medication" class="tab-pane fade">
                    <h3>Medication Suggestion</h3>
                    <% if(appointments == ""){ %>
                        <h4 class="text-center">No Medications Suggested yet.</h4>
                    <% }else{ %>
                      <div class="table-responsive mt-5">
                        <table class="table table-bordered table-striped table-hover users-table mb-2">
                          <thead>
                            <tr>
                              <th>Medicine Name</th>
                              <th>Date Prescribed</th>
                              <th>Date Started Taking</th>
                              <th>Date Stopped Taking</th>
                              <th>Dispense Quantity</th>
                              <th>Dosage Quantity</th>
                              <th>Pharmacy Note</th>
                              <th>status</th>
                            </tr>
                          </thead>
                          <tbody>
                            <% medications.forEach(function(medication, medicationIndex){  %>
                            <tr>
                                <td><%= (medication.name) ? medication.name : "-" %></td>
                                <td><%= (medication.date_prescribed) ? moment(medication.date_prescribed).format( 'llll') : "-" %></td>
                                <td><%= (medication.date_started_taking) ? moment(medication.date_started_taking).format( 'llll') : "-" %></td>
                                <td><%= (medication.date_stopped_taking) ? moment(medication.date_stopped_taking).format( 'llll') : "-" %></td>
                                <td><%= (medication.dispense_quantity) ? medication.dispense_quantity : "-" %></td>
                                <td><%= (medication.dosage_quantity) ? medication.dosage_quantity : "-" %></td>
                                <td><%= (medication.pharmacy_note) ? medication.pharmacy_note : "-" %></td>
                                <td><%= (medication.status) ? medication.status : "-" %></td>
                            </tr>
                            <% }) %>
                          </tbody>
                        </table>
                      </div>
                    <% } %>

                  </div>
                  <div id="tests" class="tab-pane fade">
                    <h3>Tests</h3>
                    <% if(appointments == ""){ %>
                        <h4 class="text-center">No Tests yet.</h4>
                    <% }else{ %>
                      <div class="table-responsive mt-5">
                        <table class="table table-bordered table-striped table-hover users-table mb-2">
                          <thead>
                            <tr>
                              <th>DRChrono Appointment ID</th>
                              <th>Date</th>
                              <th>Type</th>
                              <th>Sub Type</th>
                              <th>Location</th>
                              <th>createdAt</th>
                              <th class="no-sort">Actions</th>
                            </tr>
                          </thead>
                          <tbody>
                            <% appointments.forEach(function(appointment, appointmentIndex){
                              if(appointment.appointmentType != "Appointment"){
                              %>
                            <tr>
                                <td><%= (appointment.drChronoAppintmentID) ? appointment.drChronoAppintmentID : "-" %></td>
                                <td><%= (appointment.scheduled_time) ? moment(appointment.scheduled_time).format('DD.MM.YYYY') : "-" %></td>
                                <td><%= (appointment.appointmentType) ? appointment.appointmentType : "-" %></td>
                                <td></td>
                                <td></td>
                                <td><%= (appointment.createdAt) ? moment(appointment.createdAt).format('DD.MM.YYYY') : "-" %></td>
                                <td>
                                  <button class="btn" data-toggle="modal" data-target="#appointment_<%= appointment._id %>" ><i class="fa fa-eye"></i></button>
                                </td>
                            </tr>
                            <!-- Details Modal -->
                                <div class="modal fade" id="appointment_<%= appointment._id %>" role="dialog">
                                  <div class="modal-dialog">
                                                  <!-- Modal content-->
                                   <div class="modal-content">
                                     <div class="modal-header">
                                       <button type="button" class="close" data-dismiss="modal">&times;</button>
                                       <h4 class="modal-title">Appointment Details</h4>
                                     </div>
                                     <div class="modal-body">
                                       <div class="generalDetails">
                                         <fieldset>
                                            <legend>General info </legend>
                                             <span class="col-md-6">DRChrono Appointment ID</span> <span class="col-md-6"><%= (appointment.drChronoAppintmentID) ?  appointment.drChronoAppintmentID : "-" %></span>
                                             <span class="col-md-6">DRChrono PatientID</span> <span class="col-md-6"><%= (appointment.patientID) ?  appointment.patientID : "-" %></span>
                                             <span class="col-md-6">Scheduled Time</span> <span class="col-md-6"><%= (appointment.scheduled_time) ?  appointment.scheduled_time : "-" %></span>
                                             <span class="col-md-6">Status</span> <span class="col-md-6"><%= (appointment.status) ?  appointment.status : "-" %></span>
                                             <span class="col-md-6">Notes</span>
                                             <span class="col-md-6">
                                               <textarea rows="5" cols="26" disabled><%= appointment.notes %></textarea>
                                             </span>
                                           </fieldset>
                                       </div>
                                     </div>
                                     <div class="clearfix"></div>
                                     <div class="modal-footer">
                                       <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                                     </div>
                                   </div>

                                 </div>
                               </div>
                          <!-- Details Modal -->
                            <% }
                          }) %>
                          </tbody>
                        </table>
                      </div>
                    <% } %>
                  </div>

                </div>

              </div>
            </div>
          </div>
        </div>
    <% } %>
  </div>
</div>

<%- include('../partials/footer.ejs'); -%>
<script>
  $(document).ready(function() {
      $(".users-table").DataTable({
        "aaSorting": [],
        "columnDefs": [ {
          "targets": 'no-sort',
          "orderable": false,
        } ]
      });
      $(document).on('click', '#updatepassword', function(){
        $('#updatepassword').hide()
        $('#password').show()

      })

      $(document).on('click', '#updatePatientButton', function(){
        $('#updatePatient').submit()

      })

      // Create form submit
        $('.updateForm').submit(function(e) {
            e.preventDefault();
            let patID = $(this).data('id')

            var email = $('#email').val();
            var password = $('#password').val();
            var firstName = $('#firstName').val();
            var lastName = $('#lastName').val();
            var status = $('#status').val();
            var patientID = $('#patientID').val();
            var doctorID = $('#doctorID').val();
            var phone = $('#phone').val();

            if(status == ""){
              $('.errorCreatePatient').show()
              $('.errorCreatePatient').html("Status is required")
              setTimeout(function(){ $('.errorCreatePatient').hide() }, 3000)
              return false
            }
            if(patientID == ""){
              $('.errorPatient').show()
              $('.errorPatient').html("DR ChronoID is required")
              setTimeout(function(){ $('.errorPatient').hide() }, 3000)
              return false
            }
            if(firstName == ""){
              $('.errorPatient').show()
              $('.errorPatient').html("First Name is required")
              setTimeout(function(){ $('.errorPatient').hide() }, 3000)
              return false
            }
            if(lastName == ""){
              $('.errorPatient').show()
              $('.errorPatient').html("Last Name is required")
              setTimeout(function(){ $('.errorPatient').hide() }, 3000)
              return false
            }
            if(email == ""){
              $('.errorPatient').show()
              $('.errorPatient').html("Email is required")
              setTimeout(function(){ $('.errorPatient').hide() }, 3000)
              return false
            }
            const re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
            if (!re.test(email)) {
              $('.errorPatient').show()
              $('.errorPatient').html("Please enter a valid email")
              setTimeout(function(){ $('.errorPatient').hide() }, 3000)
              return false
            }

            $(this).ajaxSubmit({
                url: "/members/update?patientID="+patID,
                type: "POST",
                error: function(xhr) {
                  $('.errorPatient').show()
                  $('.errorPatient').html(xhr.responseJSON.message)
                  setTimeout(function(){ $('.errorPatient').hide() }, 3000);
                },
                success: function(response) {
                    if(response.status == "error"){
                      $('.errorPatient').show()
                      $('.errorPatient').html(response.message)
                      setTimeout(function(){ $('.errorPatient').hide() }, 3000);
                    }else{
                      $('.successPatient').show()
                      $('.successPatient').html(response.message)
                      setTimeout(function(){ location.reload() }, 1000);
                    }
                }
            });
            //Very important line, it disable the page refresh.
            return false;
        });

      $( ".select2Dropdown" ).select2();
    });
</script>

</body>
</html>
